<!DOCTYPE html>

<html lang="en" data-content_root="../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>Tutorial for new module &#8212; pydecha 0.3+13.g1a2fafa.dirty documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=b3523f8e" />
    <link rel="stylesheet" type="text/css" href="../_static/alabaster.css?v=cb25574f" />
    <script src="../_static/documentation_options.js?v=2fb7d489"></script>
    <script src="../_static/doctools.js?v=888ff710"></script>
    <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Modules CCD" href="modules_ccd.html" />
    <link rel="prev" title="Getting started" href="../introduction/first_steps.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="tutorial-for-new-module">
<h1>Tutorial for new module<a class="headerlink" href="#tutorial-for-new-module" title="Link to this heading">¶</a></h1>
<section id="creating-a-new-module">
<h2>Creating a new module<a class="headerlink" href="#creating-a-new-module" title="Link to this heading">¶</a></h2>
<p>In order to create a new module, you can use the creation module mode
(cm). This module will allow you to create a module in a specific pipeline
(either CCD or CMOS) with every file needed for acquisition, analysis and
reporting.</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>cm<span class="w"> </span><span class="o">{</span>pipeline<span class="o">}</span><span class="w"> </span><span class="o">{</span>modulename<span class="o">}</span>
</pre></div>
</div>
<dl class="field-list simple">
<dt class="field-odd">param pipeline<span class="colon">:</span></dt>
<dd class="field-odd"><p>CCD or CMOS</p>
</dd>
<dt class="field-even">param modulename<span class="colon">:</span></dt>
<dd class="field-even"><p>name of the module (with normal chars)</p>
</dd>
</dl>
<p>In our example we will create a new module in the CMOS pipeline and then
integrate it in PYDECHA.</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>cm<span class="w"> </span>cmos<span class="w"> </span>demo
Module<span class="w"> </span>demo<span class="w"> </span>created<span class="w"> </span><span class="k">in</span><span class="w"> </span>&lt;PYDECHAPATH&gt;/pydecha/pydecha/modules/cmos/.
</pre></div>
</div>
<p>This will create a new module in pydecha/modules/cmos/demo/.</p>
</section>
<section id="modify-the-analysis-module">
<h2>Modify the analysis module<a class="headerlink" href="#modify-the-analysis-module" title="Link to this heading">¶</a></h2>
<p>Opening the module located in pydecha/modules/cmos/demo_analysis/demo_analysis.py.</p>
<p>The module inherit from the analysis class which allows to define common
methods and arguments between all analysis modules, such as:</p>
<dl class="field-list simple">
<dt class="field-odd">self.logger<span class="colon">:</span></dt>
<dd class="field-odd"><p>is the logger where the information can be written</p>
</dd>
<dt class="field-even">self.module_parameters<span class="colon">:</span></dt>
<dd class="field-even"><p>the full dictionnary containing module and general information</p>
</dd>
</dl>
<p id="module-classes.analysis_module">Created on Wed May 15 13:57:44 2019
&#64;author: bserra</p>
<dl class="py class">
<dt class="sig sig-object py" id="classes.analysis_module.analysis">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">classes.analysis_module.</span></span><span class="sig-name descname"><span class="pre">analysis</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">module_name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yaml_dict</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis" title="Link to this definition">¶</a></dt>
<dd><p>Analysis block object which defines the common methods between all
analysis modules.</p>
<dl class="py method">
<dt class="sig sig-object py" id="classes.analysis_module.analysis.save_param">
<span class="sig-name descname"><span class="pre">save_param</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">var_name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">var_value</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis.save_param" title="Link to this definition">¶</a></dt>
<dd><p>Save a variable name and a value in the dictionnary that
can then be used for another module in the pipeline.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="classes.analysis_module.analysis.save_map">
<span class="sig-name descname"><span class="pre">save_map</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">metadata</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'FITS'</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis.save_map" title="Link to this definition">¶</a></dt>
<dd><p>Save a numpy array in a FITS file, if there are metadata (dict),
the keywords will be saved in the primaryHDU header.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="classes.analysis_module.analysis.save_fig">
<span class="sig-name descname"><span class="pre">save_fig</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">fig</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">savename</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis.save_fig" title="Link to this definition">¶</a></dt>
<dd><p>Save a matplotlib.figure object as a png.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="classes.analysis_module.analysis.print_output">
<span class="sig-name descname"><span class="pre">print_output</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis.print_output" title="Link to this definition">¶</a></dt>
<dd><p>Method to display a dictionnary properly</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="classes.analysis_module.analysis.clean_output">
<span class="sig-name descname"><span class="pre">clean_output</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis.clean_output" title="Link to this definition">¶</a></dt>
<dd><p>Method to format an output dictionnary if needed
DOES NOTHING FOR NOW</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="classes.analysis_module.analysis.get_dataset_info">
<span class="sig-name descname"><span class="pre">get_dataset_info</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">file_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'FITS'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">parameters</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">save</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#classes.analysis_module.analysis.get_dataset_info" title="Link to this definition">¶</a></dt>
<dd><p>Method to get information from a list of FITS files into a pandas
DataFrame and saving it to excel in a self.module_name sheet</p>
<dl class="field-list simple">
<dt class="field-odd">Param<span class="colon">:</span></dt>
<dd class="field-odd"><p>file_list : list : list of FITS files</p>
</dd>
<dt class="field-even">Param<span class="colon">:</span></dt>
<dd class="field-even"><p>file_type: str [FITS]</p>
</dd>
<dt class="field-odd">Param<span class="colon">:</span></dt>
<dd class="field-odd"><p>save: bool</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<hr class="docutils" />
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># -*- coding: utf-8 -*-</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Some docstring about the module</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="c1"># IMPORTS</span>
<span class="c1">#########################</span>
<span class="c1"># PYDECHA specific modules and classes</span>
<span class="kn">import</span> <span class="nn">methods.plot_methods</span> <span class="k">as</span> <span class="nn">plotm</span>
<span class="kn">from</span> <span class="nn">classes.analysis_module</span> <span class="kn">import</span> <span class="n">analysis</span>
<span class="c1"># Standard modules</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">glob</span> <span class="k">as</span> <span class="nn">glob</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>


<span class="c1"># METHODS &amp; CLASSES</span>
<span class="c1">#########################</span>
<span class="k">class</span> <span class="nc">module</span><span class="p">(</span><span class="n">analysis</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;Example class with documented types</span>

<span class="sd">        :param None: analysis module initialize with the parameters from the yaml conf. file</span>

<span class="sd">        :return None: The return value. Nothing for now...</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">def</span> <span class="nf">start</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
<span class="w">                </span><span class="sd">&quot;&quot;&quot;&quot;&quot;&quot;</span>
                <span class="c1"># logger is the logger initialized in analysis_module.analysis</span>
                <span class="c1"># depending of the severity of the error the user can use:</span>
                <span class="c1"># logger.info/warning/error/critical</span>
                <span class="n">logger</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">logger</span>
                <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s1">&#39;Starting _TEMPLATE analysis...&#39;</span><span class="p">)</span>
                <span class="c1"># _TEMPLATE code goes here</span>
                <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;_TEMPLATE analysis module&#39;</span><span class="p">)</span>
                <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;_TEMPLATE parameters&#39;</span><span class="p">)</span>
                <span class="c1"># self.module_parameters is a dictionnary containing the module information</span>
                <span class="c1"># that were written in the .yaml configuration file</span>
                <span class="nb">print</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">module_parameters</span><span class="p">)</span>
                <span class="n">file_list</span> <span class="o">=</span> <span class="n">glob</span><span class="o">.</span><span class="n">glob</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">module_parameters</span><span class="o">+</span><span class="s1">&#39;*.fits&#39;</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">get_dataset_info</span><span class="p">(</span><span class="n">file_list</span><span class="p">,</span>
                                                          <span class="n">file_type</span><span class="o">=</span><span class="s1">&#39;FITS&#39;</span><span class="p">,</span>
                                                          <span class="n">save</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

                <span class="c1"># _TEMPLATE analysis</span>
                <span class="c1"># Creating an empty dataset</span>
                <span class="n">data_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="mi">1000</span><span class="p">,</span> <span class="mi">1000</span><span class="p">))</span>
                <span class="c1"># Creating a figure</span>
                <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
                <span class="c1"># saving a parameter can be done using self.save_param</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">save_param</span><span class="p">(</span><span class="s1">&#39;_TEMPLATE variable name&#39;</span><span class="p">,</span> <span class="s1">&#39;Variable value&#39;</span><span class="p">)</span>
                <span class="c1"># saving a figure in</span>
                <span class="c1"># &#39;outputs/YYYYMMDD_DETECTOR/YYYYMMDD__TEMPLATE-figurename.png&#39;</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">save_fig</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="s1">&#39;figurename&#39;</span><span class="p">)</span>
                <span class="c1"># saving a map to FITS, all information in module_parameters will</span>
                <span class="c1"># be put in the header</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">save_map</span><span class="p">(</span><span class="n">data_array</span><span class="p">,</span>
                                          <span class="n">metadata</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">module_parameters</span><span class="p">,</span> <span class="n">file_type</span><span class="o">=</span><span class="s1">&#39;FITS&#39;</span><span class="p">)</span>

                <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s1">&#39;Ending _TEMPLATE analysis...&#39;</span><span class="p">)</span>
                <span class="c1"># if self.information was updated (for example using self.save_param)</span>
                <span class="c1"># returning it will save this info in the output yaml file.</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">clean_output</span><span class="p">()</span>


<span class="c1"># MAIN</span>
<span class="c1">#########################</span>
<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
        <span class="k">pass</span>
</pre></div>
</div>
<p>Each python analysis module inherits from analysis_module class with a start method.</p>
</section>
<section id="adding-a-new-module-to-pydecha">
<h2>Adding a new module to PYDECHA<a class="headerlink" href="#adding-a-new-module-to-pydecha" title="Link to this heading">¶</a></h2>
<p>Once the module is created, you will need to create a new configuration
file (demo_config.yaml).</p>
<div class="highlight-yaml notranslate"><div class="highlight"><pre><span></span><span class="c1">################</span>
<span class="c1"># pydecha configuration file for characterization</span>
<span class="c1"># Used and modified by Benoit</span>
<span class="c1"># 21/06/2019 - Creation date</span>
<span class="c1">################</span>

<span class="nt">general</span><span class="p">:</span>
<span class="w">  </span><span class="nt">date_fmt</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;%Y-%m-%d_%H-%M-%S&#39;</span>
<span class="w">  </span><span class="nt">author</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;Hari</span><span class="nv"> </span><span class="s">Seldon&#39;</span>
<span class="w">  </span><span class="nt">setup</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;setupname&#39;</span>
<span class="w">  </span><span class="nt">detector</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;detectornumber&#39;</span>
<span class="w">  </span><span class="nt">version</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;&#39;</span>
<span class="w">  </span><span class="nt">savepath</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;outputs/&#39;</span>

<span class="nt">workflow</span><span class="p">:</span>
<span class="w">  </span><span class="nt">type</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;cmos&#39;</span>
<span class="w">  </span><span class="nt">list</span><span class="p">:</span>
<span class="w">        </span><span class="c1"># module_name:[acquisition?, analysis?, reporting?]</span>
<span class="w">        </span><span class="nt">demo</span><span class="p">:</span><span class="w"> </span><span class="p p-Indicator">[</span><span class="nv">False</span><span class="p p-Indicator">,</span><span class="nv">True</span><span class="p p-Indicator">,</span><span class="nv">False</span><span class="p p-Indicator">]</span>

<span class="nt">acquisition</span><span class="p">:</span>
<span class="w">  </span><span class="nt">template</span><span class="p">:</span>
<span class="w">        </span><span class="nt">path</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;modules/template/template_acquisition.sh&#39;</span>
<span class="w">  </span><span class="nt">list</span><span class="p">:</span>
<span class="w">        </span><span class="nt">demo</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;&#39;</span>

<span class="nt">analysis</span><span class="p">:</span>
<span class="w">  </span><span class="nt">template</span><span class="p">:</span>
<span class="w">        </span><span class="nt">path</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;modules/template/template_analysis/template_pythonscript.py&#39;</span>
<span class="w">  </span><span class="nt">list</span><span class="p">:</span>
<span class="w">        </span><span class="nt">demo</span><span class="p">:</span>
<span class="w">          </span><span class="nt">module_name</span><span class="p">:</span><span class="w"> </span><span class="kt">!!python/module:demo_analysis</span>
<span class="w">          </span><span class="nt">data_path</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;pathtodata&#39;</span>
<span class="w">          </span><span class="nt">module_params</span><span class="p">:</span>
<span class="w">                </span><span class="nt">param1</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">2</span>
<span class="w">                </span><span class="nt">param2</span><span class="p">:</span>
<span class="w">                  </span><span class="nt">a</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;string&#39;</span>
<span class="w">                  </span><span class="nt">b</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">3.14</span>
<span class="w">          </span><span class="nt">output</span><span class="p">:</span>


<span class="nt">report</span><span class="p">:</span>
<span class="w">  </span><span class="nt">type</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;characterization&#39;</span>
<span class="w">  </span><span class="nt">template</span><span class="p">:</span>
<span class="w">        </span><span class="nt">path</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;modules/template/template_comments.yml&#39;</span>
<span class="w">  </span><span class="nt">list</span><span class="p">:</span>
<span class="w">        </span><span class="nt">demo</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;&#39;</span>
</pre></div>
</div>
</section>
<section id="running-the-new-pipeline">
<h2>Running the new pipeline<a class="headerlink" href="#running-the-new-pipeline" title="Link to this heading">¶</a></h2>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="p">&amp;</span><span class="w"> </span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>char<span class="w"> </span>cmos<span class="w"> </span>demo_config.yaml

demo<span class="w"> </span>analysis<span class="w"> </span>module
<span class="m">100</span>%<span class="p">|</span><span class="c1">############| 10000/10000 [00:00&lt;00:00, 3329341.17it/s]</span>
WARNING:<span class="w"> </span>VerifyWarning:<span class="w"> </span>Keyword<span class="w"> </span>name<span class="w"> </span><span class="s1">&#39;data_path&#39;</span><span class="w"> </span>is<span class="w"> </span>greater<span class="w"> </span>than<span class="w"> </span><span class="m">8</span><span class="w"> </span>characters<span class="w"> </span>or<span class="w"> </span>contains<span class="w"> </span>characters<span class="w"> </span>not<span class="w"> </span>allowed<span class="w"> </span>by<span class="w"> </span>the<span class="w"> </span>FITS<span class="w"> </span>standard<span class="p">;</span><span class="w"> </span>a<span class="w"> </span>HIERARCH<span class="w"> </span>card<span class="w"> </span>will<span class="w"> </span>be<span class="w"> </span>created.<span class="w"> </span><span class="o">[</span>astropy.io.fits.card<span class="o">]</span>
</pre></div>
</div>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="p">&amp;</span><span class="w"> </span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>-vvv<span class="w"> </span>char<span class="w"> </span>cmos<span class="w"> </span>demo_config.yaml

<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,092<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                          </span>start<span class="w">     </span>Starting<span class="w"> </span>the<span class="w"> </span>pipelines...
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,128<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                          </span>start<span class="w">      </span>---------<span class="w"> </span>demo<span class="w"> </span>---------
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,160<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                          </span>start<span class="w">     </span>&lt;bound<span class="w"> </span>method<span class="w"> </span>pipelines.acquisition<span class="w"> </span>of<span class="w"> </span>&lt;classes.pipelines.pipelines<span class="w"> </span>object<span class="w"> </span>at<span class="w"> </span>0x000001A4F1BA7390&gt;&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>to<span class="w"> </span>False
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,189<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                          </span>start<span class="w">     </span>&lt;bound<span class="w"> </span>method<span class="w"> </span>pipelines.analysis<span class="w"> </span>of<span class="w"> </span>&lt;classes.pipelines.pipelines<span class="w"> </span>object<span class="w"> </span>at<span class="w"> </span>0x000001A4F1BA7390&gt;&gt;
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,220<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                       </span>analysis<span class="w">     </span>Analysis<span class="w"> </span>module<span class="w"> </span>starts...
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,248<span class="w"> </span>-<span class="w"> </span>demo<span class="w"> </span>-<span class="w">                       </span>__init__<span class="w">          </span>Initializing<span class="w"> </span>analysis<span class="w"> </span>object<span class="w"> </span><span class="k">for</span><span class="w"> </span>demo
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:11:50,429<span class="w"> </span>-<span class="w"> </span>demo<span class="w"> </span>-<span class="w">                          </span>start<span class="w">          </span>Starting<span class="w"> </span>demo<span class="w"> </span>analysis...
demo<span class="w"> </span>analysis<span class="w"> </span>module
<span class="m">100</span>%<span class="p">|</span><span class="c1">############| 10000/10000 [00:00&lt;00:00, 3329341.17it/s]</span>
WARNING:<span class="w"> </span>VerifyWarning:<span class="w"> </span>Keyword<span class="w"> </span>name<span class="w"> </span><span class="s1">&#39;data_path&#39;</span><span class="w"> </span>is<span class="w"> </span>greater<span class="w"> </span>than<span class="w"> </span><span class="m">8</span><span class="w"> </span>characters<span class="w"> </span>or<span class="w"> </span>contains<span class="w"> </span>characters<span class="w"> </span>not<span class="w"> </span>allowed<span class="w"> </span>by<span class="w"> </span>the<span class="w"> </span>FITS<span class="w"> </span>standard<span class="p">;</span><span class="w"> </span>a<span class="w"> </span>HIERARCH<span class="w"> </span>card<span class="w"> </span>will<span class="w"> </span>be<span class="w"> </span>created.<span class="w"> </span><span class="o">[</span>astropy.io.fits.card<span class="o">]</span>
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:12:13,018<span class="w"> </span>-<span class="w"> </span>astropy<span class="w"> </span>-<span class="w">                   </span>_showwarning<span class="w">       </span>VerifyWarning:<span class="w"> </span>Keyword<span class="w"> </span>name<span class="w"> </span><span class="s1">&#39;data_path&#39;</span><span class="w"> </span>is<span class="w"> </span>greater<span class="w"> </span>than<span class="w"> </span><span class="m">8</span><span class="w"> </span>characters<span class="w"> </span>or<span class="w"> </span>contains<span class="w"> </span>characters<span class="w"> </span>not<span class="w"> </span>allowed<span class="w"> </span>by<span class="w"> </span>the<span class="w"> </span>FITS<span class="w"> </span>standard<span class="p">;</span><span class="w"> </span>a<span class="w"> </span>HIERARCH<span class="w"> </span>card<span class="w"> </span>will<span class="w"> </span>be<span class="w"> </span>created.
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:12:21,323<span class="w"> </span>-<span class="w"> </span>demo<span class="w"> </span>-<span class="w">                          </span>start<span class="w">          </span>Ending<span class="w"> </span>demo<span class="w"> </span>analysis...
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:12:21,563<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                       </span>analysis<span class="w">     </span>Analysis<span class="w"> </span>module<span class="w"> </span>ends...
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:12:21,598<span class="w"> </span>-<span class="w"> </span>pydecha_pipelines<span class="w"> </span>-<span class="w">                          </span>start<span class="w">     </span>&lt;bound<span class="w"> </span>method<span class="w"> </span>pipelines.report<span class="w"> </span>of<span class="w"> </span>&lt;classes.pipelines.pipelines<span class="w"> </span>object<span class="w"> </span>at<span class="w"> </span>0x000001A4F1BA7390&gt;&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>to<span class="w"> </span>False
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:12:23,450<span class="w"> </span>-<span class="w"> </span>pydecha<span class="w"> </span>-<span class="w">                       </span>&lt;module&gt;<span class="w">       </span>PYDECHA,<span class="w"> </span>version<span class="w"> </span>v0.2-63-g02cda26
<span class="m">2019</span>-07-21<span class="w"> </span><span class="m">10</span>:12:23,484<span class="w"> </span>-<span class="w"> </span>pydecha<span class="w"> </span>-<span class="w">                       </span>&lt;module&gt;<span class="w">       </span>Executed<span class="w"> </span><span class="k">in</span><span class="w"> </span><span class="m">57</span>.84096312522888
</pre></div>
</div>
</section>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">pydecha</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Introduction</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../introduction/pydecha.html">PYDECHA</a></li>
<li class="toctree-l1"><a class="reference internal" href="../introduction/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../introduction/first_steps.html">Getting started</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Characterization modules</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="current reference internal" href="#">Tutorial for new module</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#creating-a-new-module">Creating a new module</a></li>
<li class="toctree-l2"><a class="reference internal" href="#modify-the-analysis-module">Modify the analysis module</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#classes.analysis_module.analysis"><code class="docutils literal notranslate"><span class="pre">analysis</span></code></a><ul>
<li class="toctree-l4"><a class="reference internal" href="#classes.analysis_module.analysis.save_param"><code class="docutils literal notranslate"><span class="pre">analysis.save_param()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#classes.analysis_module.analysis.save_map"><code class="docutils literal notranslate"><span class="pre">analysis.save_map()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#classes.analysis_module.analysis.save_fig"><code class="docutils literal notranslate"><span class="pre">analysis.save_fig()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#classes.analysis_module.analysis.print_output"><code class="docutils literal notranslate"><span class="pre">analysis.print_output()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#classes.analysis_module.analysis.clean_output"><code class="docutils literal notranslate"><span class="pre">analysis.clean_output()</span></code></a></li>
<li class="toctree-l4"><a class="reference internal" href="#classes.analysis_module.analysis.get_dataset_info"><code class="docutils literal notranslate"><span class="pre">analysis.get_dataset_info()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#adding-a-new-module-to-pydecha">Adding a new module to PYDECHA</a></li>
<li class="toctree-l2"><a class="reference internal" href="#running-the-new-pipeline">Running the new pipeline</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="modules_ccd.html">Modules CCD</a></li>
<li class="toctree-l1"><a class="reference internal" href="modules_cmos.html">Modules CMOS</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">About</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../about/acronyms.html">Acronyms</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/changelog.html">Change log</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/faq.html">FAQ</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/references.html">References</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
      <li>Previous: <a href="../introduction/first_steps.html" title="previous chapter">Getting started</a></li>
      <li>Next: <a href="modules_ccd.html" title="next chapter">Modules CCD</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2019, European Southern Observatory.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../_sources/modules/new_module.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>